import { ILogger } from '../interface';
export declare type LogLevel = 'log' | 'error' | 'warn' | 'debug' | 'verbose';
export declare class Logger implements ILogger {
    protected context?: string;
    private readonly isTimestampEnabled;
    protected static instance?: typeof Logger | ILogger;
    private static logLevels;
    private static lastTimestamp?;
    static overrideLogger(logger: ILogger | LogLevel[] | boolean): void;
    static log(message: any, context?: string, isTimeDiffEnabled?: boolean): void;
    static error(message: any, trace?: string, context?: string, isTimeDiffEnabled?: boolean): void;
    static warn(message: any, context?: string, isTimeDiffEnabled?: boolean): void;
    static debug(message: any, context?: string, isTimeDiffEnabled?: boolean): void;
    static verbose(message: any, context?: string, isTimeDiffEnabled?: boolean): void;
    static getTimestamp(): string;
    private static printMessage;
    private static updateAndGetTimestampDiff;
    private static printStackTrace;
    constructor(context?: string, isTimestampEnabled?: boolean);
    error(message: any, trace?: string, context?: string): void;
    log(message: any, context?: string): void;
    warn(message: any, context?: string): void;
    debug(message: any, context?: string): void;
    verbose(message: any, context?: string): void;
    setContext(context: string): void;
    getTimestamp(): string;
    protected getInstance(): typeof Logger | ILogger;
    private callFunction;
    private isLogLevelEnabled;
}
