var fs_extra_1 = require('fs-extra');
var path_1 = require('path');
var services_1 = require('./services');
var spawnSync = require('child_process').spawnSync;
/**
 * @description 获取组件路径
 * @param name
 * @param provider
 * @param componentPathRoot 组件根目录
 */
exports.generateComponentPath = async({ name: name, provider: provider }, IComponentParams, componentPathRoot, string), exports.Promise = ;
{
    var Response = await, getComponentVersion_1 = ({ name: name, provider: provider });
    var rootPath = "./" + name + "-" + provider + "@" + Response.Version;
    // 如果有根路径
    if (componentPathRoot) {
        return {
            componentPath: path_1["default"].resolve(componentPathRoot, rootPath),
            componentVersion: Response.Version,
            lockPath: path_1["default"].resolve(componentPathRoot, rootPath, '.s.lock')
        };
    }
    else {
        var componentPath = path_1["default"].resolve(name);
        return {
            componentPath: componentPath,
            componentVersion: Response.Version,
            lockPath: path_1["default"].resolve(componentPath, '.s.lock')
        };
    }
}
;
exports.installDependency = async(name, string, { componentPath: componentPath, componentVersion: componentVersion, lockPath: lockPath }, IComponentPath);
{
    var existPackageJson = fs_extra_1["default"].existsSync(path_1["default"].join(componentPath, 'package.json'));
    var existNodeModules = fs_extra_1["default"].existsSync(path_1["default"].join(componentPath, 'node_modules'));
    if (existPackageJson && !existNodeModules) {
        console.log('Installing dependencies in serverless-devs core ...');
        var result = spawnSync('npm install --registry=https://registry.npm.taobao.org', [], {
            cwd: componentPath,
            stdio: 'inherit',
            shell: true
        });
        if (result && result.status !== 0) {
            throw Error('> Execute Error');
        }
    }
    await;
    fs_extra_1["default"].writeFileSync(lockPath, name + "-" + componentVersion);
}
;
exports.downloadComponent = async(outputDir, string, { name: name, provider: provider }, IComponentParams);
{
    await;
    fs_extra_1["default"].ensureDirSync(outputDir);
    var Response = await, getComponentDownloadUrl_1 = ({ name: name, provider: provider });
    await;
    services_1.execComponentDownload(Response.Url, outputDir);
}
;
exports.buildComponentInstance = async(context, IComponentContext, componentPath, string, id ?  : string, componentAlias ?  : string);
{
    var requiredComponentPath = componentPath.lastIndexOf('index') > -1 ? componentPath : path_1["default"].join(componentPath, 'index');
    var baseChildComponent = await, require = (requiredComponentPath);
    var ChildComponent = baseChildComponent.default ? baseChildComponent.default : baseChildComponent;
    var childComponentId = id + "." + (componentAlias || ChildComponent.name);
    var childComponentInstance = new ChildComponent(childComponentId, context);
    if (childComponentInstance.init) {
        await;
        childComponentInstance.init();
    }
    return childComponentInstance;
}
;
